%define ver_major 2.26
%define ver_base 2.26
%define ver_lib 1.2

%def_disable debug
%def_disable static
%def_with sys_db4
%def_with openldap
%def_disable static_ldap
%def_with krb5
%def_enable nntp
%def_enable gnome_keyring
%def_disable gtk_doc

# Use stricter build settings than required by upstream. 
%define strict_build_settings 1

Name: evolution-data-server
Version: %ver_major.3
Release: alt2

Summary: Evolution Data Server
License: %lgpl2plus
Group: Graphical desktop/GNOME
URL: http://www.gnome.org/projects/evolution/
Packager: GNOME Maintainers Team <gnome@packages.altlinux.org>

Source: %gnome_ftp/%name/%ver_major/%name-%version.tar.bz2
Patch1: %name-1.4.2.1-debug-lock.patch
Patch2: %name-2.26.3-krb5-libs.patch
Patch3: %name-2.24.0-as-needed.patch

Patch7: evolution-data-server-1.0.2-workaround-cal-backend-leak.patch
Patch8: evolution-1.4.4-ldap-x86_64-hack.patch
Patch9: evolution-data-server-1.2.2-fix_open_calendar_declaration.patch

Patch10: %name-ntlm-ldap.patch

# RH bug #215702 / GNOME bug #487988
Patch14: evolution-data-server-1.8.0-fix-ldap-query.patch

# GNOME bug #373146
Patch23: evolution-data-server-1.10.1-camel-folder-summary-crash.patch

# RH bug #243296
Patch24: evolution-data-server-1.10.3.1-fix-64bit-acinclude.patch

# from configure.in
%define glib_ver 2.16.1
%define gtk_ver 2.10.0
%define orbit_ver 2.9.8
%define libbonobo_ver 2.20.3
%define libgnome_ver 2.20.0
%define libsoup_ver 2.3.0
%define gnomekeyring_ver 2.20.1
%define sqlite_ver 3.5
%define gweather_ver 2.25.4
%define ical_ver 0.43

Requires: libbonobo2 >= %libbonobo_ver
Requires: libgnome >= %libgnome_ver
Requires: libsoup >= %libsoup_ver
Requires: glib2 >= %glib_ver

BuildConflicts: evolution-data-server-devel

BuildPreReq: rpm-build-gnome rpm-build-licenses
BuildPreReq: gtk-doc >= 1.0

BuildPreReq: gnome-common
BuildPreReq: glib2-devel >= %glib_ver
BuildPreReq: libgtk+2-devel >= %gtk_ver
BuildPreReq: ORBit2-devel >= %orbit_ver
BuildPreReq: libbonobo-devel >= %libbonobo_ver
BuildPreReq: libGConf-devel
BuildPreReq: libglade-devel
BuildPreReq: libgnome-devel >= %libgnome_ver
BuildPreReq: libxml2-devel
BuildPreReq: libsoup-devel >= %libsoup_ver
BuildPreReq: libsqlite3-devel >= %sqlite_ver
BuildPreReq: libgweather-devel >= %gweather_ver
BuildPreReq: libical-devel >= %ical_ver

BuildRequires: docbook-utils flex bison gcc-c++ libcom_err-devel libnss-devel libnspr-devel

%if_with sys_db4
BuildRequires: libdb4-devel
%endif
%if_with krb5
BuildRequires: libkrb5-devel
%endif

%if_with openldap
BuildRequires: libldap-devel 
%if_enabled static_ldap
BuildRequires: libldap-devel-static libssl-devel libsasl2-devel 
%endif
%endif

%if_enabled gnome_keyring 
BuildRequires: libgnome-keyring-devel >= %gnomekeyring_ver
%endif

%description
Evolution Data Server provides a central location for
addressbook and calendar in the GNOME Desktop.

%package devel
Summary: Development files for Evolution Data Server
Group: Development/C
Requires: %name = %version-%release

%description devel
This package provides development files for Evolution Data Server

%package devel-doc
Summary: Development documentation for Evolution Data Server
Group: Development/C
Conflicts: %name < %version-%release
BuildArch: noarch

%description devel-doc
Evolution Data Server provides a central location for
addressbook and calendar in the GNOME Desktop.

This package contains development documentation for Evolution Data Server.

%define _gtk_docdir %_datadir/gtk-doc/html
%define _libexecdir %_prefix/libexec/%name

%add_findprov_lib_path %_libdir/%name-%ver_lib/extensions

%prep
%setup -q
rm -f m4/libtool.m4 m4/lt*.m4

%if_enabled debug
%patch1 -p1
%endif

%patch2 -p1
%patch3 -p1

%patch7 -p1 -b .workaround-cal-backend-leak
# patch8 don't work, if run autoreconf
%patch8 -p1 -b .ldaphack
%patch9 -p1 -b .fix_open_calendar_declaration
%patch10 -p1
%patch14 -p1 -b .fix-ldap-query
%patch23 -p1 -b .camel-folder-symmary-crash
%patch24 -p1 -b .fix-64bit-acinclude

gtkdocize

%if_with sys_db4
rm -rf libdb
%__subst '/libdb\/Makefile/d' configure.in
%__subst 's/^\(SUBDIRS.*\)\$(LIBDB)/\1/' Makefile.am
%endif

########################################################
# --as-needed fixes (depend on patch3)

# fix for dep ordering so we can add libedataserverui to libexchange-storage
# we need to do this or: undefined reference to `e_passwords_get_password'
# are the kinds of errors you will get.

# move the groupwise backend and provider for addressbook, camel, and
# calendar to its own folder called server.deps.
mkdir server.deps
mkdir server.deps/calendar
mkdir server.deps/addressbook
mv addressbook/backends/groupwise server.deps/addressbook/
mv addressbook/backends/google server.deps/addressbook/
mv camel/providers/groupwise server.deps/camel
mv calendar/backends/groupwise server.deps/calendar/
mv calendar/backends/google server.deps/calendar/

# now fix the autotools foo for the new directory and the removed ones
echo "SUBDIRS = addressbook camel calendar" > server.deps/Makefile.am
echo "SUBDIRS = groupwise google" > server.deps/addressbook/Makefile.am
echo "SUBDIRS = groupwise google" > server.deps/calendar/Makefile.am

# remove groupwise folder from Makefile's since they are in a diff location
sed -i -e 's: groupwise::' addressbook/backends/Makefile.am camel/providers/Makefile.am calendar/backends/Makefile.am
sed -i -e 's: google::' addressbook/backends/Makefile.am calendar/backends/Makefile.am

# fix configure.in location of the Makefile's
sed -i -e 's:addressbook/backends/google:server.deps/addressbook/google:' configure.in
sed -i -e 's:addressbook/backends/groupwise:server.deps/addressbook/groupwise/Makefile\nserver.deps/addressbook:' configure.in
sed -i -e 's:camel/providers/groupwise:server.deps/camel:' configure.in
# tack on the server.deps Makefile on our last edit
sed -i -e 's:calendar/backends/groupwise:server.deps/calendar/groupwise:' configure.in
sed -i -e 's:calendar/backends/google:server.deps/calendar/google/Makefile\nserver.deps/calendar/Makefile\nserver.deps:' configure.in

# fix file includes
sed -i -e 's:<backends/groupwise/e-book-backend-groupwise.h>:"server.deps/addressbook/groupwise/e-book-backend-groupwise.h":' addressbook/libedata-book/e-data-book-factory.c
#########################################################

%build

%if_with openldap 
%if_enabled static_ldap
%define ldap_flags --with-openldap=yes --with-static-ldap 
# Set LIBS so that configure will be able to link with static LDAP libraries, 
# which depend on Cyrus SASL and OpenSSL.  XXX Is the "else" clause necessary? 
if pkg-config openssl ; then
        export LIBS="-lsasl2 `pkg-config --libs openssl`"
else
        export LIBS="-lsasl2 -lssl -lcrypto"
fi
%else
%define ldap_flags --with-openldap=yes
%endif
%else
%define ldap_flags --without-openldap
%endif

export CPPFLAGS="-I%{_includedir}/et"
export CFLAGS="$RPM_OPT_FLAGS -DLDAP_DEPRECATED -fPIC -I%{_includedir}/et"

# Add stricter build settings here as the source code gets cleaned up. 
# We want to make sure things like compiler warnings and avoiding deprecated 
# functions in the GNOME/GTK+ libraries stay fixed. 
# 
# Please file a bug report at bugzilla.gnome.org if these settings break 
# compilation, and encourage the upstream developers to use them. 

%if %{strict_build_settings}
CFLAGS="$CFLAGS \
	-DPANGO_DISABLE_DEPRECATED=1 \
	-DGDK_PIXBUF_DISABLE_DEPRECATED=1 \
	-DGDK_DISABLE_DEPRECATED=1 \
	-Wdeclaration-after-statement \
	-Werror-implicit-function-declaration"
%endif

intltoolize --copy --force
%autoreconf

export ac_cv_path_SENDMAIL=%_sbindir/sendmail
%configure \
%if_enabled debug
    --with-e2k-debug \
%endif
%if_with sys_db4
    --with-libdb=%_prefix \
%endif
    %{subst_enable static} \
    --enable-file-locking=fcntl \
    --enable-dot-locking=no \
    %ldap_flags \
    %{subst_enable nntp} \
    --enable-nss \
    --enable-smime \
%if_enabled gnome_keyring
    --enable-gnome-keyring \
%endif
    --with-nspr-libs=%_libdir \
    --with-nspr-includes=%_includedir/nspr \
    --with-nss-libs=%_libdir \
    --with-nss-includes=%_includedir/nss \
%if_with krb5
    --with-krb5=%_prefix \
    --with-krb5-libs=%_libdir \
    --with-krb5-includes=%_includedir/krb5 \
%endif
    %{?_enable_gtk_doc:--enable-gtk-doc} \
    --disable-schemas-install

%make_build

%install
%make_install DESTDIR=%buildroot install

# if unstable
#ln -s camel-lock-helper-1.2 %buildroot%_libdir/%name/camel-lock-helper

# remove none-packaged files
rm -f %buildroot%_libdir/%name-%ver_lib/*/*.la

%find_lang --with-gnome --output=%name.lang %name-%ver_base

%files -f %name.lang
%dir %_libexecdir
%_libexecdir/*
%_libdir/%name-%ver_lib
%_libdir/*.so.*
%_libdir/bonobo/servers/*
%_datadir/idl/*
%_datadir/%name-*
%_datadir/pixmaps/*
%doc AUTHORS ChangeLog NEWS README MAINTAINERS

%files devel
%_includedir/*
%_libdir/*.so
%_libdir/pkgconfig/*

%files devel-doc
%_gtk_docdir/*

%changelog
* Sat Oct 10 2009 Yuri N. Sedunov <aris@altlinux.org> 2.26.3-alt2
- relaxed strict build settings

* Mon Jun 29 2009 Yuri N. Sedunov <aris@altlinux.org> 2.26.3-alt1
- 2.26.3
- fixed krb5 detection

* Mon May 18 2009 Yuri N. Sedunov <aris@altlinux.org> 2.26.2-alt1
- 2.26.2

* Fri May 08 2009 Yuri N. Sedunov <aris@altlinux.org> 2.26.1.1-alt2
- fixed build with new libtool_2.2

* Wed Apr 15 2009 Yuri N. Sedunov <aris@altlinux.org> 2.26.1.1-alt1
- 2.26.1.1

* Tue Apr 14 2009 Yuri N. Sedunov <aris@altlinux.org> 2.26.1-alt1
- 2.26.1

* Mon Mar 16 2009 Yuri N. Sedunov <aris@altlinux.org> 2.26.0-alt1
- 2.26.0
- drop upstreamed patches

* Wed Mar 11 2009 Yuri N. Sedunov <aris@altlinux.org> 2.25.92-alt1
- 2.25.92

* Thu Jan 22 2009 Yuri N. Sedunov <aris@altlinux.org> 2.25.5-alt1
- 2.25.5
- updated buildreqs

* Mon Jan 12 2009 Yuri N. Sedunov <aris@altlinux.org> 2.24.3-alt1
- 2.24.3
- fixed build from SVN (thanks shaba@)

* Mon Nov 24 2008 Yuri N. Sedunov <aris@altlinux.org> 2.24.2-alt1
- 2.24.2
- removed obsolete *ldconfig from %%post{,un}

* Fri Nov 07 2008 Yuri N. Sedunov <aris@altlinux.org> 2.24.1.1-alt1
- 2.24.1.1
- don't rebuild documentation

* Mon Oct 20 2008 Yuri N. Sedunov <aris@altlinux.org> 2.24.1-alt1
- 2.24.1

* Sat Sep 27 2008 Alexey Shabalin <shaba@altlinux.ru> 2.24.0-alt1
- 2.24.0

* Mon Jun 30 2008 Alexey Shabalin <shaba@altlinux.ru> 2.22.3-alt1
- 2.22.3

* Fri May 30 2008 Alexey Shabalin <shaba@altlinux.ru> 2.22.2-alt1
- 2.22.2

* Fri May 02 2008 Alexey Shabalin <shaba@altlinux.ru> 2.22.1.1-alt1
- 2.22.1.1

* Tue Apr 08 2008 Alexey Shabalin <shaba@altlinux.ru> 2.22.1-alt1
- 2.22.1
- changed libexec dir to %_prefix/libexec/%name

* Mon Mar 17 2008 Alexey Shabalin <shaba@altlinux.ru> 2.22.0-alt1.1
- build for Sisyphus

* Fri Mar 14 2008 Alexey Shabalin <shaba@altlinux.ru> 2.22.0-alt1
- 2.22

* Mon Feb 04 2008 Alexey Shabalin <shaba@altlinux.ru> 1.12.3-alt1
- 1.12.3
- Removed patch for GNOME bug #363695 (causes issues)
- Add patch for RH bug #215702 / GNOME bug #487988 (fix ldap query)
- Run gtkdocize to avoid requiring gtk-doc 1.9

* Thu Nov 29 2007 Alexey Shabalin <shaba@altlinux.ru> 1.12.2-alt1
- 1.12.2

* Wed Nov 21 2007 Alexey Shabalin <shaba@altlinux.ru> 1.12.1-alt2
- fix link with libedataserverui (evolution-data-server-1.11.3-as-needed.patch)
- remove set_verify_elf_method unresolved=relaxed

* Thu Oct 25 2007 Alexey Shabalin <shaba@altlinux.ru> 1.12.1-alt1
- 1.12.1
- Disable patch for GNOME bug #376991 for now.  It may be contributing
  to password prompting problems as described in RH bug #296671.
- Remove patch for GNOME bug #420167 (fixed upstream)

* Fri Oct 12 2007 Alexey Shabalin <shaba@altlinux.ru> 1.12.0-alt1
- 1.12.0
- Add support build with static ldap (default disable-> %%def_disable ldap_static)
- Add Requires: glib2 >= 2.14.0, since it's in the buildroot now, and
  forcibly introduces deps on symbols that don't exist in 2.13.  If
  only we had working symbol versioning.
- Add Requires: libbonobo >= 2.20.0, libgnome >= 2.20.0
- Add patch for GNOME bug #420167 (fix e-d-s leaks)
- Revise patches:
  + mandriva patch for fix empty error dialog in non utf8 locale
  + GNOME bug #417999 to fix GNOME bug #447591 
    (Automatic Contacts combo boxes don't work).
  + evolution-data-server-1.8.0-no-gnome-common.patch 
    so that we no longer have to run autoconf before building.
  + GNOME bug #363695 evolution-data-server-1.9.1-kill-ememory.patch
    (deprecate EMemPool, EStrv, EPoolv).
  + GNOME bug #376991.
- Remove patches:
  + RH bug #203058 (fixed upstream)
  + RH bug #210142 (fixed upstream)
  + GNOME bug #360240 (fixed upstream)
  + GNOME bug #360619 (fixed upstream)
  + GNOME bug #373117 (fixed upstream)
  + GNOME bug #415891 (fixed upstream)
  + GNOME bug #415922 (fixed upstream)
  + RH bug #215634 (fixed upstream)
  + GNOME bug #466987 (fixed upstream)

* Fri Aug 17 2007 Alexey Shabalin <shaba@altlinux.ru> 1.10.3.1-alt1
- Updated to 1.10.3.1
- change packager
- add/remove patches from fc7

* Sun Mar 25 2007 Ilya Mashkin <oddity@altlinux.ru> 1.8.3-alt2
- add some patches
- add URL

* Sat Feb 24 2007 Ilya Mashkin <oddity@altlinux.ru> 1.8.3-alt1
- Updated to 1.8.3

* Mon Jan 01 2007 Ilya Mashkin <oddity@altlinux.ru> 1.8.2-alt1
- New release 1.8.2

* Mon Oct 02 2006 Mikhail Zabaluev <mhz@altlinux.ru> 1.8.1-alt1
- Release 1.8.1

* Tue Sep 05 2006 Mikhail Zabaluev <mhz@altlinux.ru> 1.8.0-alt1
- Release 1.8.0
- Patch0 has gone upstream
- Enabled gnome-keyring
- Buildreq

* Fri Sep 01 2006 Mikhail Zabaluev <mhz@altlinux.ru> 1.6.3-alt1
- Release 1.6.3

* Thu Jun 01 2006 Mikhail Zabaluev <mhz@altlinux.ru> 1.6.2-alt1
- Release 1.6.2

* Sat Apr 15 2006 Mikhail Zabaluev <mhz@altlinux.ru> 1.6.1-alt1
- Release 1.6.1

* Wed Mar 15 2006 Mikhail Zabaluev <mhz@altlinux.ru> 1.6.0-alt1
- Release 1.6.0

* Thu Mar 09 2006 Mikhail Zabaluev <mhz@altlinux.ru> 1.5.92-alt2
- Patch0: Adopted the dynamic libdb patch from Ross Burton (GNOME bug 319393)
- Enabled sys_db4 by default after a discussion on evolution-hackers
- Patch2: proper use of variables affecting the krb5 library test
- Relaxed the unresolved symbol check (proper fix blocked by GNOME bug 334169)

* Sun Mar 05 2006 Mikhail Zabaluev <mhz@altlinux.ru> 1.5.92-alt1
- 1.5.92

* Thu Feb 16 2006 Mikhail Zabaluev <mhz@altlinux.ru> 1.5.91-alt1
- Updated to 1.5.91

* Thu Feb 02 2006 ALT QA Team Robot <qa-robot@altlinux.org> 1.4.2.1-alt2.1
- Rebuilt for new pkg-config dependencies.

* Sat Jan 07 2006 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2.1-alt2
- Explicit dependency on libnss and libnspr

* Wed Dec 14 2005 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2.1-alt1
- 1.4.2.1

* Wed Nov 30 2005 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2-alt2
- Disable system libdb patch by default in hope to stop
  index corruption
- Compile with separately installed libnspr and libnss

* Tue Nov 29 2005 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2-alt1
- 1.4.2
- Run intltoolize

* Sat Nov 19 2005 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.1.1-alt2.1
- Spec cosmetics
- Drop explicit nspr/nss configure flags, relying on mozilla .pc files instead

* Sat Oct 22 2005 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.1.1-alt2
- Version required for libsoup bumped to 2.2.6

* Wed Oct 19 2005 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.1.1-alt1
- 1.4.1.1

* Tue Oct 04 2005 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.1-alt1
- 1.4.1
- Patch1 is obsolete
- Specify mozilla library directories

* Tue Sep 06 2005 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.0-alt1
- 1.4.0
- Updated Patch1

* Sun Sep 04 2005 Mikhail Zabaluev <mhz@altlinux.ru> 1.3.8-alt2
- --with-e2k-debug for the debug build
- --enable-nntp
- Correct name for lock helper (GNOME bug #305633) [Patch1]

* Fri Aug 26 2005 Mikhail Zabaluev <mhz@altlinux.ru> 1.3.8-alt1
- 1.3.8
- Updated Patch0

* Mon Aug 08 2005 Mikhail Zabaluev <mhz@altlinux.ru> 1.3.7-alt0.1
- 1.3.7

* Thu Aug 04 2005 Mikhail Zabaluev <mhz@altlinux.ru> 1.3.6.1-alt0.1
- 1.3.6.1

* Fri Jul 29 2005 Mikhail Zabaluev <mhz@altlinux.ru> 1.3.6-alt0.1
- 1.3.6

* Fri Jul 15 2005 Mikhail Zabaluev <mhz@altlinux.ru> 1.3.5-alt0.1
- 1.3.5
- Updated Patch0

* Sat Jul 02 2005 Yuri N. Sedunov <aris@altlinux.ru> 1.2.3-alt1
- 1.2.3

* Tue Apr 12 2005 Yuri N. Sedunov <aris@altlinux.ru> 1.2.2-alt1
- 1.2.2

* Thu Mar 17 2005 Yuri N. Sedunov <aris@altlinux.ru> 1.2.1-alt1
- 1.2.1

* Tue Mar 08 2005 Yuri N. Sedunov <aris@altlinux.ru> 1.2.0-alt1
- 1.2.0

* Wed Mar 02 2005 Yuri N. Sedunov <aris@altlinux.ru> 1.1.6-alt1
- 1.1.6

* Fri Feb 18 2005 Yuri N. Sedunov <aris@altlinux.ru> 1.1.5-alt1
- 1.1.5

* Sat Dec 11 2004 Yuri N. Sedunov <aris@altlinux.ru> 1.0.3-alt1
- 1.0.3
- development documentation moved to devel-doc subpackage.

* Thu Oct 28 2004 Yuri N. Sedunov <aris@altlinux.ru> 1.0.2-alt1
- 1.0.2

* Thu Sep 30 2004 Yuri N. Sedunov <aris@altlinux.ru> 1.0.1-alt1
- 1.0.1

* Tue Sep 14 2004 Yuri N. Sedunov <aris@altlinux.ru> 1.0.0-alt1
- 1.0.0

* Sun Sep 12 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.0.99-alt1
- 0.0.99

* Wed Aug 04 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.0.97-alt1
- 0.0.97

* Tue Jul 20 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.0.96-alt1
- 0.0.96

* Tue Jul 06 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.0.95-alt1
- 0.0.95

* Thu Jun 17 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.0.94.1-alt1
- 0.0.94.1

* Sat Jun 05 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.0.94-alt1
- 0.0.94

* Fri May 21 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.0.93-alt1
- 0.0.93

* Wed Apr 21 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.0.92-alt1
- 0.0.92

* Thu Apr 08 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.0.91-alt2
- rebuild against new gnutls (1.0.10)

* Tue Apr 06 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.0.91-alt1
- 0.0.91

* Sat Mar 06 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.0.90-alt1
- 0.0.90

* Thu Feb 12 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.0.7-alt2
- rebuild against libdb4.2

* Tue Feb 10 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.0.7-alt1
- 0.0.7

* Tue Jan 27 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.0.6-alt1
- First build for Sisyphus.
